<template>
  <div>
    <Map
      @onMounted="mapMounted"
    />

    <div class="map-legend">
      <div>
        <span class="map-legend-track" />
        Používaný, neobsazený úsek
      </div>
      <div>
        <span class="map-legend-used" />
        Obsazený úsek
      </div>
      <div>
        <span class="map-legend-unused" />
        Nepoužívaný úsek
      </div>
      <div>
        <span class="map-legend-siding-1" />
        Výhybka
      </div>
      <div>
        <span class="map-legend-siding-2" />
        Výhybka
      </div>
    </div>

    <q-tooltip
      v-for="station in stationAll"
      :key="station.id"
      :target="station.elem"
    >
      {{ getMapTooltip(station.elem.id) }}
    </q-tooltip>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/runtime-core'
import { useQuasar } from 'quasar'
import { TrainModel } from 'web_trains_types'

import Map from '@/components/Map/Map.vue'
import TrainDialog from '@/components/TrainDialog.vue'
import { mapService } from '@/service'
import useTrainStore from '@/store/trainStore'
import useUserStore from '@/store/userStore'

export default defineComponent({
  name: 'MapHome',
  components: { Map },
  setup (): any {
    mapService.connect()

    const $q = useQuasar()
    $q.loading.show()

    const user = useUserStore()

    const stationAll = ref<{id: number, elem: HTMLElement}[]>([])
    const trains = ref<TrainModel[]>()

    const trainStore = useTrainStore()

    trainStore.trains
      .then((data) => {
        trains.value = data
      })
      .finally(() => $q.loading.hide())

    mapService.trainPositions((positions) => {
      for (const station of stationAll.value) {
        station.elem.removeAttribute('train-id')
        for (const position of positions) {
          if (position.p === station.id) {
            station.elem.setAttribute('train-id', position.t.toString())
          }
        }
      }
    })

    const onStationClick = (clickContext: any) => {
      const trainId = document.getElementById(clickContext.target.id)?.getAttribute('train-id')
      const train = trains.value?.find((train) => train.id === Number(trainId))

      if (!train) {
        return
      }

      $q.dialog({
        component: TrainDialog,
        componentProps: {
          train: train,
          detail: !user.canCrudHwAdmin
        }
      })
    }

    const mapMounted = (pathAll: any) => {
      for (const path of pathAll) {
        path.elem.onclick = onStationClick
      }

      stationAll.value = pathAll
    }

    const getMapTooltip = (elementId: string) => {
      const trainId = document.getElementById(elementId)?.getAttribute('train-id')

      // If train is added by administration it is not in trains.value. Page must be redirected
      const train = trains.value?.find((train) => train.id === Number(trainId))

      if (!train) {
        return 'Neobsazen'
      }

      return train.name
    }

    return {
      stationAll,
      getMapTooltip,
      mapMounted
    }
  }
})

</script>
